﻿using System;
using System.IO;
using System.Drawing;
using System.Drawing.Text;
using System.Windows.Forms;

namespace Carte_Napoletane_Cs
{
    public partial class Form1 : Form
    {
        //************************************************************
        //*                                                          *
        //*   ESEMPIO DISPOSIZIONE PICTURE BOX RUN TIME CON INDICE   *
        //*   CON RECUPERO INFO AL CLICK E TRASCINAMENTO DEL MOUSE   *
        //*                                                          *
        //************************************************************

        // variabili globali modificabili all'occorrenza -----------
        int setL = 80; // partenza sinistra schema
        int setT = 40; // partenza top schema
        int gapL = 10; // distanza orizzontale tra le carte
        int gapT = 10; // distanza verticale tra le carte
        int nColonne = 10;
        int nRighe = 4;
        int Xp; // coordinata X al click del mouse all'interno della PictureBox
        int Yp; // coordinata Y al click del mouse all'interno della PictureBox
        Point LocPB; // coordinate PictureBox al click del mouse nel form
        Point[] sotto4 = new Point[5]; // coordinate delle 4 carte sotto
        PictureBox[] PB; // verrà dimensionata nColonne * nRighe

        struct Info // contiene i parametri di interesse allungabile all'occorrenza
        {
            public int L; // posizione left nativa
            public int T; // posizione top nativa
            public int ID; // indice
        }

        public Form1()
        {
            InitializeComponent();
            PB = new PictureBox[nColonne * nRighe + 1]; // se nColonne * nRighe eccede 40 non ci saranno sufficienti immagini in imagelist
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Info inf = new Info(); // in inf i parametri di interesse come dichiarato in struct Info
            int ID = 1; // indice di partenza

            // creazione e posizionamento delle 40 carte
            for (var r = 1; r <= nRighe; r++)
            {
                for (var c = 1; c <= nColonne; c++)
                {
                    PB[ID] = new PictureBox(); // una nuova picturebox
                    PB[ID].Size = ImageList1.ImageSize; // dimensione picturebox in accordo con le immagini in imagelist
                    PB[ID].Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[ID]); // nel nome il nome della carta
                    PB[ID].BackgroundImage = ImageList1.Images[ID]; // in BackgroundImage l'immagine in accordo con l'indice
                    inf.L = setL + (gapL + ImageList1.ImageSize.Width) * c; // left calcolato e immesso in inf.L
                    inf.T = setT + (gapT + ImageList1.ImageSize.Height) * (r - 1); // top calcolato e immesso in inf.T
                    inf.ID = ID; // l'indice 1...40
                    PB[ID].Location = new Point(inf.L, inf.T); // uso i parametri per posizionare la picturebox
                    PB[ID].Tag = inf; // NEL TAG TUTTI I PARAMETRI DI INTERESSE, servirà per recuperare i dati
                    PB[ID].MouseDown += PB_OnMouseDown; // al click del mouse viene eseguito il codice in PB_OnMouseDown
                    PB[ID].MouseMove += PB_OnMouseMove; // mentre si muove il mouse viene eseguito il codice in PB_OnMouseMove
                    PB[ID].MouseUp += PB_OnMouseUp; // quando si rilascia il mouse viene eseguito il codice in PB_OnMouseUp
                    this.Controls.Add(PB[ID]); // Aggiungo la picturebox creata, nel Form
                    ID += 1;
                }
            }

            // dimensione del form adeguata a contenere lo schema
            this.Width = setL + (gapL + ImageList1.ImageSize.Width) * (nColonne + 2);
            this.Height = (gapT + ImageList1.ImageSize.Height) * (nRighe + 2);
            // calcolo della posizione e dimensione della listbox
            ListBox1.Height = (gapT + ImageList1.ImageSize.Height) * (nRighe + 1);
            ListBox1.Width = 115;
            ListBox1.Top = setT;
            ListBox1.Left = 4;

            verifica(); // controllo quante carte posizionate
        }

        private void PB_OnMouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left) // click mouse sinistro
            {
                Xp = e.X; // coordinata X mouse nella picturebox al momento del click tasto sinistro, servirà per mantenere la posizione del cursore nella carta
                Yp = e.Y; // coordinata Y mouse nella picturebox al momento del click tasto sinistro, servirà per mantenere la posizione del cursore nella carta
                PictureBox p = (PictureBox)sender; // in sender c'è l'oggetto cliccato, converto in picturebox e lo immetto in p
                Info inf = (Info)p.Tag; // conversione di tipo da oggetto a info
                LocPB = p.Location; // coordinata della picturebox al momento del click tasto sinistro, all'occorrenza servirà per ripristinare la posizione della carta
                p.BringToFront(); // la picturebox cliccata passa sopra le altre
                p.Image = null; // cancellando image si scopre BackgroundImage
                                //nella barra del titolo tutte le info recuperate, in p e in p.Tag
                this.Text = "ID: " + inf.ID + " Posizione nativa = Left: " + inf.L + " Top: " + inf.T + " Posizione attuale = Left: " + p.Left + " Top: " + p.Top + " Nome = " + p.Name;
            }
        }

        private void PB_OnMouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left) // solo se mentre si muove il mouse, il tasto sinistro è premuto
            {
                PictureBox p = (PictureBox)sender; // in sender c'è l'oggetto cliccato, converto in picturebox e lo immetto in p
                Info inf = (Info)p.Tag; // conversione di tipo da oggetto a info
                p.Top = p.Top + e.Y - Yp; // trascinamento Y sul form
                p.Left = p.Left + e.X - Xp; // trascinamento X sul form
                                            //nella barra del titolo tutte le info recuperate, in p e in p.Tag
                if (p.Top + p.Height / 1.6 >= inf.T && p.Top <= inf.T + p.Height / 1.6 && p.Left + p.Width / 1.5 >= inf.L && p.Left <= inf.L + p.Width / 1.5)
                {
                    this.Text = "Posizione nell'intervallo consentito";
                    ListBox1.BackColor = Color.Green;
                }
                else
                {
                    this.Text = "ID: " + inf.ID + " Posizione nativa = Left: " + inf.L + " Top: " + inf.T + " Posizione attuale = Left: " + p.Left + " Top: " + p.Top + " Nome = " + p.Name;
                    ListBox1.BackColor = Color.Red;
                }
            }
        }

        private void PB_OnMouseUp(object sender, MouseEventArgs e)
        {
            // quando si rilascia il tasto del mouse
            // 1) controllare se le coordinate che ha la carta e quelle che dovrebbe avere + il margine ricadono nella giusta posizione
            // 2) se si, cercare la carta che occupa la posizione di destinazione
            // 3) spostare la carta che occupa la posizione di destinazione nella posizione di partenza della carta
            //    che si sta trascinando, memorizzate in LocPB al momento del click
            // 4) spostare la carta che si sta trascinando nella sua posizione nativa precisa
            // 5) se no, la carta torna dov'era
            if (e.Button == MouseButtons.Left)
            {
                PictureBox p = (PictureBox)sender; // in sender c'è l'oggetto cliccato, converto in picturebox e lo immetto in p
                Info inf = (Info)p.Tag; // conversione di tipo da oggetto a info
                if (p.Top + p.Height / 1.6 >= inf.T && p.Top <= inf.T + p.Height / 1.6 && p.Left + p.Width / 1.5 >= inf.L && p.Left <= inf.L + p.Width / 1.5)
                {
                    // cerco la carta nella posizione di destinazione
                    for (var i = 1; i <= 40; i++)
                    {
                        if (PB[i].Top == inf.T && PB[i].Left == inf.L)
                        {
                            PB[i].Location = LocPB; // sposto la carta nella posizione di destinazione, nelle coordinete di partenza
                        }
                    }
                    // dalla posizione approssimata alla posizione precisa
                    p.Top = inf.T;
                    p.Left = inf.L;
                    //nella barra del titolo tutte le info recuperate, in p e in p.Tag
                    this.Text = "ID: " + inf.ID + " Posizione nativa = Left: " + inf.L + " Top: " + inf.T + " Posizione attuale = Left: " + p.Left + " Top: " + p.Top + " Nome = " + p.Name;
                    verifica(); // controllo quante carte posizionate
                }
                else
                {
                    // la carta non è stata posizionata nei pressi della sua posizione nativa, torna da dove è partita
                    p.Location = LocPB;
                }
                ListBox1.BackColor = Color.White;
            }
        }

        private void ButMescola_Click(object sender, EventArgs e)
        {
            Random Rnd1 = new Random(DateTime.Now.Millisecond); // generatore random inizializzato a caso
            ButMescola.Enabled = false;
            // mostro il dorso delle carte
            for (var i = 1; i <= 40; i++)
            {
                PB[i].Image = ImageList1.Images[0]; // in proprietà Image il dorso, in BackgroundImage la carta resta
            }
            // calcolo le coordinate delle 4 carte sotto, le memorizzo e ci sposto i re
            for (var i = 1; i <= 4; i++)
            {
                sotto4[i] = new Point(setL + (gapL + ImageList1.ImageSize.Width) * i, setT + (gapT + ImageList1.ImageSize.Height) * nRighe + 1);
                PB[i * 10].Location = sotto4[i];
            }
            // mescolo
            for (var n = 1; n <= 2; n++) // ripeto l'operazione due volte, per maggiore mescolamento
            {
                for (var i = 1; i <= 40; i++) // scambio le coordinate attuali, scegliendo 40 carte a caso
                {
                    int rand = Rnd1.Next(1, 40);
                    Point tempLoc = PB[rand].Location; // inizio swap
                    PB[rand].Location = PB[i].Location;
                    PB[i].Location = tempLoc; // fine swap
                }
            }
            verifica(); // controllo quante carte posizionate
        }

        private void verifica()
        {
            ListBox1.Items.Clear(); // svuoto la listbox
            int QuanteSotto = 0; // svuoto QuanteSotto
            for (var i = 1; i <= 40; i++)
            {
                Info inf = (Info)(PB[i].Tag); // conversione di tipo, da oggetto a info
                // se la posizione nativa in PB(i).Tag.T e PB(i).Tag.L è uguale alla posizione attuale la carta è ordinata
                if (PB[i].Top == inf.T && PB[i].Left == inf.L)
                {
                    ListBox1.Items.Add(PB[i].Name);
                    PB[i].Image = null; // se la carta è ordinata, la scopro rimuovendo il dorso
                }
                // se la posizione sotto4(qt) è uguale alla posizione attuale la carta sta sotto
                for (var qt = 1; qt <= 4; qt++)
                {
                    if (PB[i].Location == sotto4[qt]) // conteggio carte sotto
                    {
                        QuanteSotto += 1;
                    }
                }
            }
            int ordinate = ListBox1.Items.Count;
            ListBox1.Items.Add("Totale ordinate = " + ordinate);
            ListBox1.Items.Add("Carte sotto = " + QuanteSotto);
            // le carte sono tutte ordinate oppure non ci sono più carte sotto, si può mescolare
            if (ordinate == 40 || QuanteSotto == 0)
            {
                ButMescola.Enabled = true;
            }

            if (ordinate < 40 && QuanteSotto == 0)
            {
                this.BackColor = Color.Red; // le carte non sono ordinate, ma sono finite le carte sotto
            }
            else
            {
                this.BackColor = Color.Green; // le carte sono ordinate
            }
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            StringFormat drawFormat = new StringFormat();
            drawFormat.FormatFlags = StringFormatFlags.DirectionVertical;
            e.Graphics.TextRenderingHint = TextRenderingHint.AntiAlias;
            // reticolo e testo calcolato in accordo con le variabili globali modificabili all'occorrenza
            // righe verticali e testo
            int limite = nColonne + 2;
            for (var c = 1; c < limite; c++)
            {
                int cc = setL + (gapL + ImageList1.ImageSize.Width) * c - Convert.ToInt32(gapL / 2); // cc relativo
                e.Graphics.DrawLine(Pens.DarkGray, cc, setT - 10, cc, setT + (gapT + ImageList1.ImageSize.Height) * (nRighe + 1));
                if (c <= nColonne)
                {
                    e.Graphics.DrawString(c.ToString(), new Font("Arial", 10, FontStyle.Bold), Brushes.DarkOrange, cc + Convert.ToSingle(ImageList1.ImageSize.Width / 2.0), setT - 24, StringFormat.GenericTypographic);
                }
            }
            // righe orizzontali e testo
            limite = nRighe + 3;
            for (var r = 1; r < limite; r++)
            {
                int rr = setT + (gapT + ImageList1.ImageSize.Height) * (r - 1) - Convert.ToInt32(gapT / 2); // rr relativo
                e.Graphics.DrawLine(Pens.DarkGray, setL + ImageList1.ImageSize.Width, rr, setL + (gapL + ImageList1.ImageSize.Width) * (nColonne + 1), rr);
                switch (r)
                {
                    case 1:
                        e.Graphics.DrawString("DENARI", new Font("Arial", 10, FontStyle.Bold), Brushes.DarkOrange, setL + Convert.ToSingle(ImageList1.ImageSize.Width / 1.3), rr + 30, drawFormat);
                        break;
                    case 2:
                        e.Graphics.DrawString("COPPE", new Font("Arial", 10, FontStyle.Bold), Brushes.DarkOrange, setL + Convert.ToSingle(ImageList1.ImageSize.Width / 1.3), rr + 30, drawFormat);
                        break;
                    case 3:
                        e.Graphics.DrawString("BASTONI", new Font("Arial", 10, FontStyle.Bold), Brushes.DarkOrange, setL + Convert.ToSingle(ImageList1.ImageSize.Width / 1.3), rr + 20, drawFormat);
                        break;
                    case 4:
                        e.Graphics.DrawString("SPADE", new Font("Arial", 10, FontStyle.Bold), Brushes.DarkOrange, setL + Convert.ToSingle(ImageList1.ImageSize.Width / 1.3), rr + 30, drawFormat);
                        break;
                }
            }
        }
    }
}
